DMFADQ = {};

local addon = DMFADQ;

addon.autoQuests = {
	[37911] = { --37868 follow quest without reward
		name = "The Real Big Race",
		camera = false,
	},
	[37910] = { --33756 is follow quest wihtout reward
		name = "The Real Race",
		camera = false,
	},
	
	[29463] = {
		name = "It's Hammer Time",
		camera = false,
	},
	[29436] = {
		name = "The Humanoid Cannonball",
		camera = false,
	},
	[29438] = {
		name = "He Shoots, He Scores!",
		camera = true,
	},
	[29434] = {
		name = "Tonk Commander",
		camera = false,
	},
	[36481] = {
		name = "Firebird's Challenge",
		camera = false,
	},
	[29455] = {
		name = "Target: Turtle",
		camera = true,
	},
}
addon.npcs = {
	[54601] = {
		name = "mole",
		quest = addon.autoQuests[29463],
	},
	[15303] = {
		name = "cannon",
		quest = addon.autoQuests[29463],
	},
	[14841] = {
		name = "rifle",
		quest = addon.autoQuests[29438],
	},
	[54605] = {
		name = "tonk",
		quest = addon.autoQuests[29434],
	},
	[85546] = {
		name = "fire rings",
		quest = addon.autoQuests[36481],
	},
	[54485] = {
		name= "turtle",
		quest = addon.autoQuests[29455],
	},
	
	--race npcs not needed because they have no gossip but show the quest directly
}

function addon.onGossipShow()
	local type, zero, serverId, instanceId, zoneUid, npcId = strsplit("-",UnitGUID("npc"));
	npcId = tonumber(npcId);
	
	if addon.npcs[npcId] ~= nil then
		addon.onGossipWithDarkmoonNpc(npcId);
	elseif 57850 == npcId then
		addon.onGossipWithDarkmoonCannonTeleportNpc();
	end
end

function addon.onGossipWithDarkmoonNpc(npcId)
	if GetNumGossipAvailableQuests() == 1 then --quest not accepted -> accept
		local name, level, isTrivial, frequency = GetGossipAvailableQuests();
		if frequency == LE_QUEST_FREQUENCY_DAILY then
			SelectGossipAvailableQuest(1);
		end
	end
	if GetNumGossipActiveQuests() == 1 then --quest active
		local name, level, isTrivial, isComplete = GetGossipActiveQuests();
		
		if isComplete then --if quest done
			SelectGossipActiveQuest(1); --open quest window to turn in
		else 
			-- automatically burn game token
			--assume game token is the second option (after tutorial)
			--better solution to be found but probably not
			--might be able to detect the blue color
			if addon.npcs[npcId].quest.camera then 
				SetView(2);
			end
			Dismount();
			SelectGossipOption(2);
		end
	end
end

function addon.onQuestShow()
	local qid = GetQuestID();
	local qlidx = GetQuestLogIndexByID(qid);
	
	if addon.autoQuests[qid] ~= nil then
		local title, level, groupsize, isHeader, isCollaped, isComplete = GetQuestLogTitle(qlidx)
		
		if title == nil then --not accepted yet
			AcceptQuest();
		elseif isComplete then --false when not complete but number when it is?
			if addon.autoQuests[qid].camera then 
				SetView(5);
			end
			GetQuestReward(1);
		end
	end
end

function addon.onGossipWithDarkmoonCannonTeleportNpc()
	--only teleport on active cannon quest
	local qlidx = GetQuestLogIndexByID(29436);
	if qlidx ~= 0 then
		SelectGossipOption(1 , "?" , true)
	end
end

GossipFrame:HookScript("OnShow", addon.onGossipShow);
QuestFrame:HookScript("OnShow", addon.onQuestShow);


SLASH_DMFADQ1 = "/dmfadq";
SlashCmdList["DMFADQ"] = function(args)
	for qid, qinfo in pairs (addon.autoQuests) do 
		print((IsQuestFlaggedCompleted(qid)and"\124cff00ff00"or"\124cffff0000")..(qinfo.name).."\124r");
	end
end;